/****************************************************************************/
/*!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*/
/*!                                                                        !*/
/*!                             .                                   !*/
/*!                                                                        !*/
/*!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*/
/****************************************************************************/

#include "Menu.h"
#include "MainMenu.h"
#include <STDDEF.h>
#include "Const.h"
#include "Ranges.h"
#include "E2PROM.h"

//-----------------------------------------------------------------------------
//  .

TMenuElement code MenuModeWork =
 {
  fMenuElement_Draw,
  fMenuElement_Handle,
  "Mode Work",
  (PAbstractElement)&MenuArchive,
  (PAbstractElement)&MenuModeALM,
  (PAbstractElement)&MenuSetSupportChannel
  };


TMenuElement code MenuModeALM =
 {
  fMenuElement_Draw,
  fMenuElement_Handle,
  "Mode ALM ",
  (PAbstractElement)&MenuModeWork,
  (PAbstractElement)&MenuSetRTC,
  (PAbstractElement)&MenuSetModeAlarm
  };


TMenuElement code MenuSetRTC =
 {
  fMenuElement_Draw,
  fMenuElement_Handle,
  "Set RTC  ",
  (PAbstractElement)&MenuModeALM,
  (PAbstractElement)&MenuArchive,
  (PAbstractElement)&MenuEditRTC
  };


TMenuElement code MenuArchive =
 {
  fMenuElement_Draw,
  fMenuElement_Handle,
  "Archive  ",
  (PAbstractElement)&MenuSetRTC,
  (PAbstractElement)&MenuModeWork,
  NULL
  };

//-----------------------------------------------------------------------------
//  .
TMenuElement code MenuWork =
 {
  fMenuWork_Draw,
  fMenuWork_Handle,
  "",
  NULL,
  NULL,
  (PAbstractElement)&MenuModeWork
  };

//-----------------------------------------------------------------------------
//   .
TMenuElement code MenuSetModeAlarm =
 {
  fMenuElement_Draw,
  fMenuElement_Handle,
  "Set mode Alarm ",
  (PAbstractElement)&MenuSetAlarmL,
  (PAbstractElement)&MenuSetAlarmH,
  (PAbstractElement)&EditModeAlarm
  };


TMenuElement code MenuSetAlarmH =
 {
  fMenuElement_Draw,
  fMenuElement_Handle,
  "Set Alarm Hight",
  (PAbstractElement)&MenuSetModeAlarm,
  (PAbstractElement)&MenuSetAlarmL,
  (PAbstractElement)&SetAlarmH
  };


TMenuElement code MenuSetAlarmL =
 {
  fMenuElement_Draw,
  fMenuElement_Handle,
  "Set Alarm Low  ",
  (PAbstractElement)&MenuSetAlarmH,
  (PAbstractElement)&MenuSetModeAlarm,
  (PAbstractElement)&SetAlarmL
  };


TMenuElementRTC code MenuEditRTC =
 {
  fMenuElementRTC_Draw,
  fMenuElementRTC_Handle,
  "Menu Set RTC"
  };


TMenuElement code MenuSetSupportChannel =
 {
  fMenuElement_Draw,
  fMenuElement_Handle,
  "The basic channel",
  (PAbstractElement)&MenuPassword,
  (PAbstractElement)&MenuTheBasicTemperature,
  (PAbstractElement)&EditBasicChannel
  };

TMenuElement code MenuPassword =
 {
  fMenuElement_Draw,
  fMenuElement_Handle,
  "Password         ",
  (PAbstractElement)&MenuTheBasicTemperature,
  (PAbstractElement)&MenuSetSupportChannel,
  (PAbstractElement)&MenuEditPassword
  };

TMenuElement code MenuTheBasicTemperature =
 {
  fMenuElement_Draw,
  fMenuElement_Handle,
  "Basic temperature",
  (PAbstractElement)&MenuSetSupportChannel,
  (PAbstractElement)&MenuPassword,
  (PAbstractElement)&EditBasicTemperature
  };

//-----------------------------------------------------------------------------
TMenuEditInteger code EditModeAlarm =
 {
  fMenuEditInteger_Draw,
  fMenuEditInteger_Handle,
  "Number channel",
  "Mode Alarm",
  NULL,
  NULL,
  cnNumberChannel,
  sizeof(unsigned char),
  cnUChar,
  eeAlarmOut,
  &RangeControlTypeOutAlarm,
  cnAT24C256
  };

TMenuEditFloat code SetAlarmH =
 {
  fMenuEditFloat_Draw,
  fMenuEditFloat_Handle,
  "Number channel",
  "Alarm H",
  NULL,
  NULL,
  cnNumberChannel,
  sizeof(float),
  cnFloat,
  eeAlarmH,
  &RangeAlarm,
  cnAT24C256
  };

TMenuEditFloat code SetAlarmL =
 {
  fMenuEditFloat_Draw,
  fMenuEditFloat_Handle,
  "Number channel",
  "Alarm L",
  NULL,
  NULL,
  cnNumberChannel,
  sizeof(float),
  cnFloat,
  eeAlarmL,
  &RangeAlarm,
  cnAT24C256
  };


TMenuEditInteger code EditBasicChannel = 
 {
  fMenuEditInteger_Draw,
  fMenuEditInteger_Handle,
  "Select basic channel",
  "Number =",
  NULL,
  NULL,
  1,
  sizeof(unsigned char),
  cnUChar,
  eeNumberBasicChannel,
  &RangeChannel,
  cnAT24C256
  };

TMenuEditFloat code EditBasicTemperature =
 {
  fMenuEditFloat_Draw,
  fMenuEditFloat_Handle,
  "Edit temperature",
  "T =",
  NULL,
  NULL,
  1,
  sizeof(float),
  cnFloat,
  eeBasicTemperature,
  &RangeAlarm,
  cnAT24C256
  };

//-----------------------------------------------------------------------------
//    .
TMenuElementError code MenuError =
 {
  fMenuElementError_Draw,
  fMenuElementError_Handle,
  "Error"
  };

//-----------------------------------------------------------------------------
//  .
TMenuPassword code MenuEditPassword =
 {
  fMenuPassword_Draw,
  fMenuPassword_Handle,
  "Enter Password",
  &RangePassword,
  (PAbstractElement)&MenuOnOffChannel
  };

//-----------------------------------------------------------------------------
//  .

// /  .
TMenuElement code MenuOnOffChannel =
 {
  fMenuElement_Draw,
  fMenuElement_Handle,
  "On/Off channel",
  (PAbstractElement)&MenuCallRref,
  (PAbstractElement)&MenuTypeSensor,
  (PAbstractElement)&EditStatusChannel,
  };

// .
TMenuElement code MenuTypeSensor =
 {
  fMenuElement_Draw,
  fMenuElement_Handle,
  "Type Sensor   ",
  (PAbstractElement)&MenuOnOffChannel,
  (PAbstractElement)&MenuCall_0_Sensor,
  (PAbstractElement)&MenuEditTypeSensor
  };

//   .
TMenuElement code MenuCall_0_Sensor =
 {
  fMenuElement_Draw,
  fMenuElement_Handle,
  "Calibrate 0   ",
  (PAbstractElement)&MenuTypeSensor,
  (PAbstractElement)&MenuCorrPoint1,
  NULL
  };

//    .
TMenuElement code MenuCorrPoint1 =
 {
  fMenuElement_Draw,
  fMenuElement_Handle,
  "Correction 1  ",
  (PAbstractElement)&MenuCall_0_Sensor,
  (PAbstractElement)&MenuCorrPoint2,
  NULL
  };

//    .
TMenuElement code MenuCorrPoint2 =
 {
  fMenuElement_Draw,
  fMenuElement_Handle,
  "Correction 2  ",
  (PAbstractElement)&MenuCorrPoint1,
  (PAbstractElement)&MenuCallUref,
  NULL
  };

//  .
TMenuElement code MenuCallUref =
 {
  fMenuElement_Draw,
  fMenuElement_Handle,
  "Calibrate Uref",
  (PAbstractElement)&MenuCorrPoint2,
  (PAbstractElement)&MenuCallRref,
  NULL
  };

//  .
TMenuElement code MenuCallRref =
 {
  fMenuElement_Draw,
  fMenuElement_Handle,
  "Calibrate Rref",
  (PAbstractElement)&MenuCallUref,
  (PAbstractElement)&MenuOnOffChannel,
  NULL
  };

//   .
TMenuEditInteger code MenuEditTypeSensor = 
 {
  fMenuEditInteger_Draw,
  fMenuEditInteger_Handle,
  "Type sensor",
  "Number =",
  NULL,
  NULL,
  cnNumberChannel,
  sizeof(unsigned char),
  cnUChar,
  eeTypeSensor,
  &RangeTypeSensors,
  cnAT24C164
  };

//
TMenuEditInteger code EditStatusChannel = 
 {
  fMenuEditInteger_Draw,
  fMenuEditInteger_Handle,
  "Channel",
  "Status =",
  NULL,
  NULL,
  cnNumberChannel,
  sizeof(unsigned char),
  cnUChar,
  eeOnOffSensor,
  &RangeStatusSensors,
  cnAT24C164
  };

