/*****************************************************************************/
/*                                    Menu.                                  */
/*****************************************************************************/

#ifndef Menu_H
#define Menu_H

 #include "Ranges.h"
 #include "Errors.h"

 #ifdef DEBUG
  #include "Meas.h"
 #endif


 typedef struct TAbstractElement1 code* PAbstractElement;
 typedef void (*PDraw)(PAbstractElement);
 typedef void (*PHandle)(PAbstractElement);

 // ------ AbstractElement ------------
 //         
 //  -   
 struct TAbstractElement1
  {
   const PDraw Draw;  //   .     
   const PHandle Handle; // -""-    (, -  ..)
   };
 //typedef struct TAbstractElement1 code TAbstractElement;
 // -----------------------------------


 //       .
 //     .
 extern int PushPointerMenu(PAbstractElement Pointer);

 //       .
 extern PAbstractElement PopPointerMenu(void);

 //  .
 extern void ClearStackPointerMenu(void);


 typedef struct TMenuElement1 code* PMenuElement;


 struct TMenuElement1
  {
   const PDraw Draw;//      
   const PHandle Handle;//      (, -  ..)
   const char* NameMenu;// .
   const PMenuElement MenuElementUP;//   .
   const PMenuElement MenuElementDown;//   .
   const PMenuElement MenuElementAlternative;//    .
   };
 typedef struct TMenuElement1 TMenuElement;



 extern void fMenuElement_Draw(PAbstractElement Element);
 extern void fMenuElement_Handle(PAbstractElement Element);

 //extern PAbstractElement PHistoryMenu;
 extern PAbstractElement PMenu;


 //      .    ^_^
 extern void Menu(void);


 extern void fMenuWork_Draw(PAbstractElement Element);
 extern void fMenuWork_Handle(PAbstractElement Element);

 //-----------------------------------------------------------------------------------------------------------

 struct TMenuElementRTC1
  {
   const PDraw Draw;//      
   const PHandle Handle;//      (, -  ..)
   const char* NameMenu;// .
//   const PMenuElement MenuElementAlternative;//    .
   };
 typedef struct TMenuElementRTC1 TMenuElementRTC;

 extern void fMenuElementRTC_Draw(PAbstractElement Element);
 extern void fMenuElementRTC_Handle(PAbstractElement Element);


 typedef struct TMenuElementRTC1 TMenuElementError;

 extern void fMenuElementError_Draw(PAbstractElement Element);
 extern void fMenuElementError_Handle(PAbstractElement Element);

 //-----------------------------------------------------------------------------------------------------------
 //         (   ).


 typedef struct TMenuEdit1 code* PMenuEditInteger;

 struct TMenuEdit1
  {
   const PDraw Draw;//      
   const PHandle Handle;//      (, -  ..)
   const char *Text0;//   0.
   const char *Text1;//   1.
   const char *Text2;//   2.
   const char *Text3;//   3.
   const unsigned char NumVar;// .
   const unsigned char SizeVar;// .
   const unsigned char TypeVar;// .
   const short AdressVar;//    EEPROMe .
   const TRange code *Range;//  .
   const unsigned char NumberEEPROM;//         E2PROM.h
   //       .
   };
 typedef struct TMenuEdit1 TMenuEditInteger;

 extern void fMenuEditInteger_Draw(PAbstractElement Element);
 extern void fMenuEditInteger_Handle(PAbstractElement Element);


 //         (   float).
 typedef struct TMenuEdit2 code* PMenuEditFloat;

 struct TMenuEdit2
  {
   const PDraw Draw;//      
   const PHandle Handle;//      (, -  ..)
   const char *Text0;//   0.
   const char *Text1;//   1.
   const char *Text2;//   2.
   const char *Text3;//   3.
   const unsigned char NumVar;// .
   const unsigned char SizeVar;// .
   const unsigned char TypeVar;// .
   const short AdressVar;//    EEPROMe.
   const TRangeFloat code *Range;//  .
   const unsigned char NumberEEPROM;//         E2PROM.h
   //       .
   };
 typedef struct TMenuEdit2 TMenuEditFloat;

 extern void fMenuEditFloat_Draw(PAbstractElement Element);
 extern void fMenuEditFloat_Handle(PAbstractElement Element);

//-----------------------------------------------------------------------------

 typedef struct TMenuPassword1 code *PMenuPassword;
//  "PASSWORD"
 struct TMenuPassword1
  {
   const PDraw Draw;//    .
   const PHandle Handle;//     .
   const char *c_string;//  .
   const TRange code *Range;//  .
   const PMenuElement MenuElementAlternative;//    .
   };
 typedef struct TMenuPassword1 TMenuPassword;

 extern void fMenuPassword_Draw(PAbstractElement Element);
 extern void fMenuPassword_Handle(PAbstractElement Element);

//-----------------------------------------------------------------------------

 typedef struct TMenuCalibrationRref1 code *PMenuCalibrationRref;
//  "CalibrationRref"
 struct TMenuCalibrationRref1
  {
   const PDraw Draw;//    .
   const PHandle Handle;//     .

   };

//-----------------------------------------------------------------------------

#endif

